//+------------------------------------------------------------------+
//|                                                     my swing.mq4 |
//|                                                             23501|
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "23510"
#property link      ""
extern double Lots = 0.1;
extern double TakeProfit = 5000;
extern double StopLoss   = 50;
extern double TrailingStop = 5000;
extern string comment = "Swing EA";
extern int magic = 432524;
extern bool Trade_Alert =true;

double sll,sls,tpl,tps;
int total;
double highline,lowline,midline,index2,index3,previndex2,previndex3;
 int cnt, ticket;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
//if(Trade_Alert)Trade_Alert();
 
 

 if(Bars<100)
     {
      Print("bars less than 100");
      return(0);  
     }
   if(TakeProfit<10)
     {
      Print("TakeProfit less than 10");
      return(0);  // check TakeProfit
     }

highline = iCustom(Symbol(),0,"i-Regr",1,1);
lowline = iCustom(Symbol(),0,"i-Regr",2,1);
midline = iCustom(Symbol(),0,"i-Regr",0,1);
index2 = iCustom(Symbol(), 0, "Heiken Ashi", 2, 6, 3, 2, 2, 0) ; // gets index2 
index3 = iCustom(Symbol(), 0, "Heiken Ashi", 2, 6, 3, 2, 3, 0) ; // gets index3 
previndex2 = iCustom(Symbol(), 0, "Heiken Ashi", 2, 6, 3, 2, 2, 2) ; // gets index2 
previndex3 = iCustom(Symbol(), 0, "Heiken Ashi", 2, 6, 3, 2, 3, 2) ; // gets index3

sll = NormalizeDouble(Ask-StopLoss*Point,Digits); // stop loss for long trade
tpl = NormalizeDouble(Ask+TakeProfit*Point,Digits); // take profit for long trade
sls = NormalizeDouble(Bid+StopLoss*Point,Digits); // stop loss for short position
tps = NormalizeDouble(Bid-TakeProfit*Point,Digits); // take profit for short position
total=OrdersTotal();
  
   if(total<1) 
     {
      // no opened orders identified
      if(AccountFreeMargin()<(1000*Lots))
        {
         Print("You have no money to trade. Free Margin = ", AccountFreeMargin());
         return(0);  
        }
        
 if (Volume[0]<5&&Close[1]<lowline&&previndex2>previndex3&&index2<index3)
   {
   ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,sls,tpl,comment,magic,0,Green);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
           }
         else Print("Error opening BUY order : ",GetLastError()); 
         return(0); 
        }
        
 if (Volume[0]<5&&Close[1]>highline&&previndex2<previndex3&&index2>index3) 
   {
   ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,sls,tps,comment,magic,0,Red);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
           }
         else Print("Error opening SELL order : ",GetLastError()); 
         return(0); 
        }
   
        return(0);
     }
     for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL &&   // check for opened position 
         OrderSymbol()==Symbol())  // check for symbol
        {
         if(OrderType()==OP_BUY)   // long position is opened
           {
            // should it be closed?
            if(Bid>=midline)
                {
                 OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet); // close position
                 return(0); // exit
                }
            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if(Bid-OrderOpenPrice()>Point*TrailingStop)
                 {
                  if(OrderStopLoss()<Bid-Point*TrailingStop)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                     return(0);
                    }
                 }
              }
           }
         else // go to short position
           {
            // should it be closed?
            if(Bid<=midline)
              {
               OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet); // close position
               return(0); // exit
              }
            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
                 {
                  if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
                     return(0);
                    }
                 }
              }
           }
        }
     } 
//----
   return(0);
  }
//+------------------------------------------------------------------+
/*void Trade_Alert()
{
/////////////////////////////
 total =OrdersTotal();
/////////////////////////////// 
 for(int cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL &&   // check for opened position 
         OrderSymbol()==Symbol())  // check for symbol
        {
         if(OrderType()==OP_BUY)   // long position is opened
           {
           AlertOnce ("BUY ORDER OPENED on:"+Symbol(),1);
           }
           if(OrderType()==OP_SELL)
           {
           AlertOnce ("SELL ORDER OPENED on:"+Symbol(),2);
           }
          }
         }
/////////////////////////////        
}

bool AlertOnce(string alert_msg, int ref)
{  
   static int LastAlert_1 = 0;
   static int LastAlert_2 = 0;
   static int LastAlert_3 = 0;
   static int LastAlert_4 = 0;
   
   switch(ref)
   {
      case 1:
         if( LastAlert_1 == 0 || LastAlert_1 < Bars )
         {
            Alert(alert_msg);
            LastAlert_1 = Bars;
            return (1);
         }
      break;
      case 2:
         if( LastAlert_2 == 0 || LastAlert_2 < Bars )
         {
            Alert(alert_msg);
            LastAlert_2 = Bars;
            return (1);
         }
      break;
      case 3:
         if( LastAlert_3 == 0 || LastAlert_3 < Bars )
         {
            Alert(alert_msg);
            LastAlert_3 = Bars;
            return (1);
         }
      break;
      case 4:
         if( LastAlert_4 == 0 || LastAlert_4 < Bars )
         {
            Alert(alert_msg);
            LastAlert_4 = Bars;
            return (1);
         }
      break;
   }
} */